/**
 *  Header for debugging related display routines.
 *
 *  Author: Ramkumar Natarajan (nrk@cs.purdue.edu)
 **/

#ifndef PRINTFUNCS_H__
#define PRINTFUNCS_H__

#include <stdio.h>
#include <ctype.h>
#include "constants.h"
#include "types.h"
#include "macros.h"

#ifdef DEBUG_
extern void printMap(int **patmap, int patpos, int *patbuf, int alpha_seen, int wordlen);
extern void printWord(char *word, int len);
extern void printDict(Dictionary *dptr, Bool printwords);
extern void printCipherWord(CipherWord *wptr);
extern void printCipherChar(CipherChar *ccptr);
extern void printCipherText(CipherText *ctptr);
#else
#define printMap(a,b,c,d,e)
#define printWord(a,b)
#define printDict(a,b)
#define printCipherWord(a)
#define printCipherChar(a)
#define printCipherText(a)
#endif

#endif
